<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarSupplier extends AbstractStructArrayBase
{
    /**
     * The RentacarSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarSupplier[]
     */
    public $RentacarSupplier;
    /**
     * Constructor method for ArrayOfJP_RentacarSupplier
     * @uses ArrayOfJP_RentacarSupplier::setRentacarSupplier()
     * @param \StructType\JP_RentacarSupplier[] $rentacarSupplier
     */
    public function __construct(array $rentacarSupplier = array())
    {
        $this
            ->setRentacarSupplier($rentacarSupplier);
    }
    /**
     * Get RentacarSupplier value
     * @return \StructType\JP_RentacarSupplier[]|null
     */
    public function getRentacarSupplier()
    {
        return $this->RentacarSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setRentacarSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRentacarSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRentacarSupplierForArrayConstraintsFromSetRentacarSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RentacarSupplierRentacarSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarSupplierRentacarSupplierItem instanceof \StructType\JP_RentacarSupplier) {
                $invalidValues[] = is_object($arrayOfJP_RentacarSupplierRentacarSupplierItem) ? get_class($arrayOfJP_RentacarSupplierRentacarSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_RentacarSupplierRentacarSupplierItem), var_export($arrayOfJP_RentacarSupplierRentacarSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RentacarSupplier property can only contain items of type \StructType\JP_RentacarSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RentacarSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarSupplier[] $rentacarSupplier
     * @return \ArrayType\ArrayOfJP_RentacarSupplier
     */
    public function setRentacarSupplier(array $rentacarSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($rentacarSupplierArrayErrorMessage = self::validateRentacarSupplierForArrayConstraintsFromSetRentacarSupplier($rentacarSupplier))) {
            throw new \InvalidArgumentException($rentacarSupplierArrayErrorMessage, __LINE__);
        }
        $this->RentacarSupplier = $rentacarSupplier;
        return $this;
    }
    /**
     * Add item to RentacarSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarSupplier $item
     * @return \ArrayType\ArrayOfJP_RentacarSupplier
     */
    public function addToRentacarSupplier(\StructType\JP_RentacarSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarSupplier) {
            throw new \InvalidArgumentException(sprintf('The RentacarSupplier property can only contain items of type \StructType\JP_RentacarSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RentacarSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarSupplier
     */
    public function getAttributeName()
    {
        return 'RentacarSupplier';
    }
}
